# include <ohana.h>
# include <dvo.h>
# include <kapa.h>
# include <signal.h>
# include <pthread.h>

/* # define GRID_V1 */
# define GRID_V2
# define NO_IMAGE -100

// choose off_t or int depending on full-scale relphot analysis resources
// # define IDX_T off_t
# define IDX_T int 

typedef enum {
    MODE_NONE   = 0,
    MODE_LOAD   = 1,
    MODE_UPDATE = 2,
    MODE_UPDATE_OBJECTS = 3,
} ModeType;

typedef struct {
  unsigned int start;
  unsigned int stop;
  short photcode;
  float Mcal;
  float dMcal;
  float dMsys;
  unsigned short nFitPhotom;
  short Xm;
  float secz;
  float ubercalDist;
  unsigned int flags;
  char skipCal;		      // if TRUE, this mosaic is incomplete and should not be calibrated
  Coords coords;
} Mosaic; 

typedef enum {
  STATS_NONE, 
  STATS_MEAN, 
  STATS_MEDIAN, 
  STATS_WT_MEAN, 
  STATS_INNER_MEAN, 
  STATS_INNER_WTMEAN, 
  STATS_CHI_INNER_MEAN, 
  STATS_CHI_INNER_WTMEAN
} ListStatsMode;

typedef struct {
  double median;
  double mean;
  double sigma;
  double error;
  double chisq;
  double min;
  double max;
  double Upper80;
  double Lower20;
  double total;
  int    Nmeas;
  ListStatsMode statmode;
} StatType;

typedef struct {
  AverageTiny *average;	      // array of (minimal) average data
  MeasureTiny *measure;	      // array of (minimal) measure data 
  SecFilt     *secfilt;	      // array of secfilt data (matched to average by Nsecfilt)
  off_t       Naverage;
  off_t       Nmeasure;
} BrightCatalog;

typedef struct {
  float Mcal;
  float dMcal;
  unsigned int imageID;
  unsigned int photom_map_id;
  unsigned int flags;
  unsigned int tzero;
  unsigned char trate;
} ImageSubset;

typedef struct {
  Catalog *catalog;	      // array of catalogs generated
  int NCATALOG;		      // number of catalogs allocated
  int Ncatalog;		      // number of catalogs generated
  int Nsecfilt;		      // number of catalogs generated
  off_t *NAVERAGE; 	      // allocated Averages per catalog
  off_t *NMEASURE;	      // allocated Measures per catalog
  int   *index;		      // lookup table catID -> catalog[i]
  int   *catIDs;	      // lookup table catID <- catalog[i]
  int    maxID;		      // max catID value to date
} CatalogSplitter;

/* global variables set in parameter file */
# define DVO_MAX_PATH 1024
char   ImageCat[DVO_MAX_PATH];
char   ImageTemplate[DVO_MAX_PATH];
char   CatTemplate[DVO_MAX_PATH];
char   GSCFILE[DVO_MAX_PATH];
char  *CATDIR;
char   CATMODE[16];    /* raw, mef, split, mysql */
char   CATFORMAT[16];  /* internal, elixir, loneos, panstarrs */
char   CameraConfig[DVO_MAX_PATH];
char   CAMERA[64];    /* eg, gpc1 */
char   SKY_TABLE[DVO_MAX_PATH];
int    SKY_DEPTH;  /** XXX EAM : depth of catalog tables, fix usage */

int          HOST_ID;
char        *HOSTDIR;
char        *IMAGES;
char        *BCATALOG;
ModeType     MODE;

double MAG_LIM;
double SIGMA_LIM;
double IMAGE_SCATTER;
double IMAGE_OFFSET;
double STAR_SCATTER;
double STAR_CHISQ;
double MIN_ERROR;
double IMFIT_SYS_SIGMA_LIM;
double CLOUD_TOLERANCE;

int    PARALLEL;
int    PARALLEL_MANUAL;
int    PARALLEL_SERIAL;

int    NTHREADS;

int    VERBOSE;
int    VERBOSE2;
int    MOSAIC_ZEROPT;

int    NLOOP;
int    NGRID;
int    RESET;
int    UPDATE;
int    SAVE_IMAGE_UPDATES;
int    PLOTSTUFF;
int    SAVEPLOT;
int    SHOW_PARAMS;
char   MOSAICNAME[256];
char   STATMODE[32];
int    STAR_BAD;
int    MEAS_BAD;
int    STAR_TOOFEW;
int    GRID_TOOFEW;
int    IMAGE_TOOFEW;
double IMAGE_GOOD_FRACTION;
int    IMAGE_BAD;
int    FREEZE_IMAGES;
int    FREEZE_MOSAICS;
int    USE_GRID;
int    KEEP_UBERCAL;
char  *OUTROOT;
char  *UPDATE_CATFORMAT;
int    PLOTDELAY;
int    UpdateAverages;
int    ApplyOffsets;

char  *PhotcodeList;

int    RELPHOT_GRID_X;
int    RELPHOT_GRID_Y;
int    RELPHOT_GRID_BINNING;

int      *photseclist;
int      Nphotcodes;
PhotCode **photcodes;
// int            PhotSec;
// int            PhotNsec;

PhotCode      *refPhotcode;

int MaxDensityUse;
double MaxDensityValue;

int AreaSelect;
double AreaXmin, AreaXmax, AreaYmin, AreaYmax;

int ImagSelect;
double ImagMin, ImagMax;

int DophotSelect, DophotValue;

double  PlotMmin, PlotMmax, PlotdMmin, PlotdMmax;
enum {black, white, red, orange, yellow, green, blue, indigo, violet};

int TimeSelect;
time_t TSTART, TSTOP;

SkyRegion UserPatch;
char *UserCatalog;

int USE_BASIC_CHECK;

# ifdef GRID_V1
int setGridMeasure (off_t meas, int cat, double X, double Y);
# endif

# ifdef GRID_V2
int setGridMeasure (off_t meas, int cat, double X, double Y, int ccdnum);
# endif

/*** relphot prototypes ***/
void          ConfigInit          PROTO((int *argc, char **argv));
void          GetConfig           PROTO((char *config, char *field, char *format, int N, void *ptr));
char         *GetPhotnamebyCode   PROTO((PhotCodeData *photcodes, int code));
void          InterpolateGrid     PROTO((float *buffer, int Nx, int Ny, Coords *ccd, Coords *gcoords));
off_t        *SelectRefMosaic     PROTO((Mosaic **refmosaic, off_t *Nimage));
int           args                PROTO((int argc, char **argv));
int           args_client         PROTO((int argc, char **argv));
int           bcatalog            PROTO((Catalog *subcatalog, Catalog *catalog, int Ncat));
void          clean_images        PROTO((void));
void          clean_measures      PROTO((Catalog *catalog, int Ncatalog, int final, FlatCorrectionTable *flatcorr));
void          clean_mosaics       PROTO((void));
void          clean_stars         PROTO((Catalog *catalog, int Ncatalog));
int           corner_check        PROTO((double *x1, double *y1, double *x2, double *y2));
void          dumpGrid            PROTO((void));
void          dump_grid           PROTO((void)); 
int           edge_check          PROTO((double *x1, double *y1, double *x2, double *y2));
void          findImages          PROTO((Catalog *catalog, int Ncatalog, int doImageList));
int           findMosaics         PROTO((Catalog *catalog, int Ncatalog, int doMosaicList));

void set_db (FITS_DB *in);
int Shutdown (char *format, ...) OHANA_FORMAT(printf, 1, 2) ;
void TrapSignal (int sig);
void SetProtect (int mode);
int SetSignals (void);

void          freeGridBins        PROTO((int Ncatalog));
void          freeImageBins       PROTO((int Ncatalog, int doImageList));
void          freeMosaicBins      PROTO((int Ncatalog, int doMosaicList));
void          free_catalogs       PROTO((Catalog *catalog, int Ncatalog));
int           gcatalog            PROTO((Catalog *catalog, int FINAL));
Coords       *getCoords           PROTO((off_t meas, int cat));
off_t         getImageEntry       PROTO((off_t meas, int cat));
float         getMcal             PROTO((off_t meas, int cat, FlatCorrectionTable *flatcorr, Catalog *catalog));
float         getMflat            PROTO((off_t meas, int cat, FlatCorrectionTable *flatcorr, Catalog *catalog));
float         getMgrid            PROTO((off_t meas, int cat));
float         getMmos             PROTO((off_t meas, int cat));
float         getMrel             PROTO((Catalog *catalog, off_t meas, int cat));
short         getUbercalDist      PROTO((off_t meas, int cat));
Image        *getimage            PROTO((off_t N));
Image        *getimages           PROTO((off_t *N, off_t **LineNumber));
ImageSubset  *getimages_subset    PROTO((off_t *N));
void          global_stats        PROTO((Catalog *catalog, int Ncatalog, FlatCorrectionTable *flatcorr));
void          initGrid            PROTO((int dX, int dY));
void          initGridBins        PROTO((Catalog *catalog, int Ncatalog));
void          initImageBins       PROTO((Catalog *catalog, int Ncatalog, int doImageList));
void          initImagesSubset    PROTO((ImageSubset *input, off_t *line_number, off_t N));
void          initImages          PROTO((Image *input, off_t *LineNumber, off_t N));
void          initMosaicBins      PROTO((Catalog *catalog, int Ncatalog, int doMosaicList));
void          initMosaicGrid      PROTO((Image *image, off_t Nimage));
void          initMosaics         PROTO((Image *subset, off_t Nsubset, Image *image, char *inSubset, off_t Nimage));
void          initMrel            PROTO((Catalog *catalog, int Ncatalog));
void          initialize          PROTO((int argc, char **argv));
void          initialize_client   PROTO((int argc, char **argv));
void          liststats_setmode   PROTO((StatType *stats, char *strmode));
int           liststats           PROTO((double *value, double *dvalue, double *wvalue, int N, StatType *stats));
Catalog      *load_catalogs       PROTO((SkyList *skylist, int *Ncatalog, int hostID, char *hostpath));
Catalog      *load_catalogs_parallel PROTO((SkyList *sky, int *Ncatalog));

SkyList      *load_images         PROTO((FITS_DB *db, char *regionName, SkyRegion *region));
Image        *select_images       PROTO((SkyList *skylist, Image *timage, off_t Ntimage, char *inSubset, off_t **LineNumber, off_t *Nimage, SkyRegion *region));

int           main                PROTO((int argc, char **argv));
void          mark_images         PROTO((Image *image, off_t Nimage, Image *timage, off_t Ntimage));
void          matchImage          PROTO((Catalog *catalog, off_t meas, int cat, int doImageList));
void          matchMosaics        PROTO((Catalog *catalog, off_t meas, int cat, int doMosaicList));
double        opening_angle       PROTO((double x1, double y1, double x2, double y2, double x3, double y3));
void          plot_chisq          PROTO((Catalog *catalog, int Ncatalog));
void          plot_defaults       PROTO((Graphdata *graphdata));
void          plot_grid           PROTO((Catalog *catalog, FlatCorrectionTable *flatcorr));
void          plot_images         PROTO((void));
void          plot_list           PROTO((Graphdata *graphdata, double *xlist, double *ylist, int N, char *label, char *format, ...) OHANA_FORMAT(printf, 6, 7) );
void          plot_mosaic_fields  PROTO((Catalog *catalog));
void          plot_mosaics        PROTO((void));
void          plot_scatter        PROTO((Catalog *catalog, int Ncatalog, FlatCorrectionTable *flatcorr));
void          plot_star_coords    PROTO((Catalog *catalog, int Ncatalog));
void          plot_stars          PROTO((Catalog *catalog, int Ncatalog));
void          reload_catalogs     PROTO((SkyList *skylist, FlatCorrectionTable *flatcorr, int hostID, char *hostpath));
int           reload_catalogs_parallel PROTO((SkyList *sky));
int           reload_images       PROTO((FITS_DB *db));
int           setExclusions       PROTO((Catalog *catalog, int Ncatalog, int verbose));
void          setMcal             PROTO((Catalog *catalog, int Poor, FlatCorrectionTable *flatcorr));
void          setMcalFinal        PROTO((void));
int           setMcalOutput       PROTO((Catalog *catalog, int Ncatalog, FlatCorrectionTable *flatcorr));
void          setMgrid            PROTO((Catalog *catalog, FlatCorrectionTable *flatcorr));
int           setMmos             PROTO((Catalog *catalog, int Poor, FlatCorrectionTable *flatcorr));
int           setMrel             PROTO((Catalog *catalog, int Ncatalog, FlatCorrectionTable *flatcorr));
void          setMrelFinal        PROTO((Catalog *catalog, FlatCorrectionTable *flatcorr, int simpleAverage));
int           setMrelOutput       PROTO((Catalog *catalog, int Ncatalog, int pass, FlatCorrectionTable *flatcorr));
int           setMave             PROTO((Catalog *catalog, int Ncatalog));
void          set_ZP              PROTO((double ZERO));
int           setrefcode          PROTO((Image *image, off_t Nimage)); 
void          skip_measurements   PROTO((Catalog *catalog, int pass, FlatCorrectionTable *flatcorr));
void          sortA               PROTO((double *X, int N));
void          sortB               PROTO((double *X, double *Y, int N));
void          sortC               PROTO((double *X, double *Y, double *F1, double *F2, int N));
void          sortD               PROTO((double *X, double *Y, double *Z, int N));
StatType      statsImageM         PROTO((Catalog *catalog));
StatType      statsImageN         PROTO((Catalog *catalog, FlatCorrectionTable *flatcorr));
StatType      statsImageX         PROTO((Catalog *catalog));
StatType      statsImagedM        PROTO((Catalog *catalog));
StatType      statsMosaicM        PROTO((Catalog *catalog));
StatType      statsMosaicN        PROTO((Catalog *catalog, FlatCorrectionTable *flatcorr));
StatType      statsMosaicX        PROTO((Catalog *catalog));
StatType      statsMosaicdM       PROTO((Catalog *catalog));
StatType      statsStarN          PROTO((Catalog *catalog, int Ncatalog, int Nsec, int seccode, FlatCorrectionTable *flatcorr));
StatType      statsStarS          PROTO((Catalog *catalog, int Ncatalog, int Nsec));
StatType      statsStarX          PROTO((Catalog *catalog, int Ncatalog, int Nsec));
void          wcatalog            PROTO((Catalog *catalog));
void          wimages             PROTO((void));
void          write_coords        PROTO((Header *header, Coords *coords));
int relphot_objects (int hostID, char *hostpath);

void relphot_usage (void);
void relphot_help (int argc, char **argv);

void relphot_client_usage (void);
void relphot_client_help (int argc, char **argv);

off_t getImageByID (off_t ID);

int rationalize_mosaics PROTO((Catalog *catalog, int Ncatalog));
int LimitDensityCatalog (Catalog *subcatalog, Catalog *catalog);

BrightCatalog *BrightCatalogLoad(char *filename);
int BrightCatalogSave(char *filename, BrightCatalog *catalog);
BrightCatalog *BrightCatalogMerge (Catalog *catalog, int Ncatalog);
CatalogSplitter *BrightCatalogSplitInit (int Nsecfilt);
int BrightCatalogSplitFree (CatalogSplitter *catalogs);
int BrightCatalogSplit (CatalogSplitter *catalogs, BrightCatalog *bcatalog);

int ImageSubsetSave(char *filename, ImageSubset *image, off_t Nimage);
ImageSubset *ImageSubsetLoad(char *filename, off_t *nimage);

int client_logger_init ();
int client_logger_message (char *format,...);

